/*
 ********************************************************
	Rug Warrior Pro UMH-ISA (SITR)
 ********************************************************
	NOMBRE DEL ARCHIVO:   	sonido.c
	FECHA:			
	AUTOR:   
	DESCRIPCIN:  
				  
	VARIABLES GLOBALES EXTERNAS:
		int listen_p = 1;
		int sound_count = 0;
		int s_level_max = 0;
		int sound_delta = 50;
		long hold_time = 175L;
		int loud_p = 0;

    FUNCIONES EXTERNAS: 
		void sample_sound();
		int monitor_sound(int count);

	VARIABLES GLOBALES USO INTERNO:

    FUNCIONES USO INTERNO: 

 ********************************************************
*/

/* Empirically, the most easily heard (by a second robot) combination is
   LOW = 1500, HIGH = 1600, Dur = a minimum of 0.008
*/


/* Sample the microphone to see how much noise there is */
/* Output: sound_count, s_level_max	*/
int listen_p = 1;		     /* Make it 0 during echo execution */
int sound_count = 0;
int s_level_max = 0;
int sound_delta = 50;   /* Must be low for robots to hear each other */
long hold_time = 175L;		/* Numer of milliseconds to hold high time */
int loud_p = 0;         /* 0 => quite, 1 => loud */

void sample_sound()
{ 
  int s_level = 0;		/* Instantaneous sound level */
  long go_low_time = 0L;
  long current_time = 0L;
  
  while (1)
  { 
	while(listen_p)
	{ 
		current_time = mseconds();
		s_level = abs(analog(microphone) - 128);	/* Abs difference from 128 */
		if (s_level > s_level_max)
			s_level_max = s_level;
		if ( s_level > sound_delta)
			go_low_time = current_time + hold_time;	/* Compute new go low time */
		if (current_time > go_low_time)
			loud_p = 0;
		else
	    { 
			if (loud_p == 0)	/* Was 0, now 1 => add to transition count */
				sound_count++;
			loud_p = 1; 
		}
	}
  }
}


/* busca un sonido muestreando count veces */
/* devuelve el mximo valor - el mnimo */
int monitor_sound(int count)
{ 
  int k,val, max, min;
  k = 0;
  max = 0;
  min = 255;

  while (k < count)
    { 
	  k++;
      val = analog(microphone);	/* Read mic */
      if (val > max)
		max = val;
      if (val < min)
		min = val;
    }
  return max - min;
}
